Subject: Re: syntaxe lilypond

From: Xavier Scheuer <[email-masked]>
Date: Thu, 23 Dec 2010 13:46:57 +0100

Copie à la liste.
D'autres personnes pourraient être intéressées par ce sujet ou
pourraient donner des informations complémentaires (ou autres "trucs").
;-)

2010/12/23 Giroux, Didier <[email-masked]>:
>
> merci. en complément de votre réponse j'aimerais savoir si on peut
> affecter des sonorités différentes ? car je codifie une partition
> pour flûte, hautbois, clarinette, basson. puis-je affecter une
> sonorité à chacun pour les reconnaître et les entendre distinctement
> après écriture ?  la syntaxe donné par le site Lilypond indique :
> \score <<  \new Staff {musique}
> puis \new Staff {musique} >>  est-ce qu'il est possible donc
> d'affecter un instrument à chaque ligne d'écriture ? comment  le
> fichier"midi" reconnait-il l'affectation réservée à chaque instrument ?

C'est tout à fait possible.
Je vous invite à lire la section  3.5 MIDI output  du manuel de notation
(en anglais seulement... pour le moment).
http://lilypond.org/doc/v2.13/Documentation/notation/midi-output

Vous y trouverez des explications au sujet de la sortie MIDI et
notamment l'utilisation de  "midiInstrument"  qui permet d'affecter la
sonorité d'un instrument à une portée.

\new Staff {
  \set Staff.midiInstrument = #"flute"
  ...notes...
}

OU

\new Staff \with { midiInstrument = #"oboe" } {
  ...notes...
}

La liste des noms d'instruments MIDI utilisables est reprise ici :
http://lilypond.org/doc/v2.13/Documentation/notation/midi-instruments

> dans votre réponse vous m'avez indiqué \midi {  }  ; qu'y a-t-il
> entre les parenthèses ? merci de vos informations complémentaires.

Entre les accolades ?  Rien.  ;D
En fait le  \midi {}  (à l'intérieur du bloc  \score )  a pour but de
signifier à LilyPond que vous souhaitez une sortie sous forme de fichier
MIDI.
Si vous utilisez  \midi {}  mais souhaitez *aussi* une sortie sous forme
de fichier PDF (la partition), il faut ajouter  \layout {}  (toujours
à l'intérieur du bloc  \score ).

Cf. exemple (minimal) ci-dessous pour un conducteur flûte, hautbois.

\version "2.13.43"  % toujours mettre la version utilisée.

flute = \relative c'' {
  c1
  % les notes
}

hautbois = \relative a' {
  a1
  % les notes
}

\score {
  <<
    \new Staff \with {
      instrumentName = #"Flute"  % nom imprimé (premier système)
      midiInstrument = #"flute"  % son MIDI
    } {
      \flute
    }
    \new Staff \with {
      instrumentName = #"Hautbois"
      midiInstrument = #"oboe"
    } {
      \hautbois
    }
  \midi {}  % sortie MIDI
  \layout {}  % sortie PDF
}

Cordialement,
Xavier

-- 
Xavier Scheuer <[email-masked]>

---

From: Xavier Scheuer <[email-masked]>
Date: Mon, 27 Dec 2010 10:02:42 +0100

2010/12/27 Giroux, Didier <[email-masked]>:
>
> merci de votre information. j'ai terminé le codage et j'ai indiqué
> \midi et \layout ocmme vous me l'avez indiqué. que dois-je faire
> ensuite pour entendre ce que j'ai écrit? je veux dire : comment
> générer le son ? faut-il copier le fichier dans
>  \midi ? car même si j'ai écrit \midi en fin de codage le son ne
> démarre pas automatiquement.  merci de votre réponse car je ne sais
> pas comment faire....

Normalement LilyPond a créé un fichier MIDI (dans le même dossier que
votre fichier  .ly ) en même temps que le fichier PDF.
Double-cliquez sur ce fichier  .midi  (ou peut-être  .mid  sous Windows)
et il devrait s'ouvrir sans problème avec Windows Media Player (toujours
si vous utilisez Windows).
Et vous devriez entendre le son de votre partition (ne pas oublier
d'activer ses haut-parleurs).  ;-)

Si vous n'avez pas de fichier MIDI généré ou si vous avez des messages
d'erreur, merci de joindre votre fichier  .ly  à votre prochain message.

Cordialement,
Xavier